SystemOrganization addCategory: #'EjerciciosPoo-Metaprogramacion1'!

TestCase subclass: #XXXTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 18:57'!
test01AMethodWithSubclassResponsabilityIsAbstract

	self assert: (AClassWithAnAbstractMethod methodNamed: #m) isAbstract! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 18:59'!
test02ClassWithAnAbstractMethodCannotPerformIt

	self deny: (AClassWithAnAbstractMethod canPerform: #m)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:00'!
test03SubclassThatDoesntImplementTheAbstractMethodCannotPerformIt

	self deny: (ASubclassThatDoesntImplementTheMethod canPerform: #m)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:00'!
test04SubclassThatImplementsTheAbstractMethodCanPerformIt

	self assert: (ASubclassThatImplementsTheMethod canPerform: #m)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:05'!
test05AClassWithAnAbstractMethodAndNoSubclassesShouldBeConsideredAsHavingMissingImplementorsOfThatMethod

	self assert: ((XXX new lookForMissingImplementorsOf: #m ofClass: AClassWithAbstractMethodAndNoSubclasses) includes: AClassWithAbstractMethodAndNoSubclasses)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:07'!
test06ThereShouldBeNoMissingImplementorsOfAMethodOfAClassIfThatClassImplementsIt

	self assert: (XXX new lookForMissingImplementorsOf: #m ofClass: AClassWithNoAbstractMethods) isEmpty! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:09'!
test07SubclassThatImplementsTheMethodShouldNotBeConsideredMissingAnImplementorOfIt

	self deny: ((XXX new lookForMissingImplementorsOf: #m ofClass: AClassWithAnAbstractMethod) includes: ASubclassThatImplementsTheMethod)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:11'!
test08SubclassThatDoesntImplementTheMethodShouldBeConsideredMissingAnImplementor

	self assert: ((XXX new lookForMissingImplementorsOf: #m ofClass: AClassWithAnAbstractMethod) includes: ASubclassThatDoesntImplementTheMethod)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:13'!
test09NonLeafSubclassThatDoesntImplementTheMethodShouldNotBeConsideredMissingAnImplementorOfIt

	self deny: ((XXX new lookForMissingImplementorsOf: #m ofClass: AnotherClassWithAnAbstractMethod) includes: ASubclassThatDoesntImplementTheMethodAndHasASubclass)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:15'!
test10LookForMissingImplementorsWorksAlsoForSubclassesOfSubclasses

	self assert: ((XXX new lookForMissingImplementorsOf: #m ofClass: AnotherClassWithAnAbstractMethod) includes: ALeafSubclassThatStillDoesntImplementTheMethod)! !

!XXXTest methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 19:16'!
test11LeafSubclassThatDoesntImplementTheMethodShouldNotBeInMissingImplementorsOfItIfOneOfItsSuperclassesImplementsIt

	self deny: ((XXX new lookForMissingImplementorsOf: #m ofClass: AnotherClassWithAnAbstractMethod) includes: ALeafSubclassThatDoesntImplementTheMethod)! !

Object subclass: #AClassWithAbstractMethodAndNoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!AClassWithAbstractMethodAndNoSubclasses methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/21/2013 20:57'!
m

	self subclassResponsibility! !

Object subclass: #AClassWithAnAbstractMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!AClassWithAnAbstractMethod methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/20/2013 18:06'!
m

	self subclassResponsibility! !

AClassWithAnAbstractMethod subclass: #ASubclassThatDoesntImplementTheMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

AClassWithAnAbstractMethod subclass: #ASubclassThatImplementsTheMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!ASubclassThatImplementsTheMethod methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/21/2013 22:04'!
m

	^1! !

Object subclass: #AClassWithNoAbstractMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!AClassWithNoAbstractMethods methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/21/2013 21:24'!
m

	^1! !

AClassWithNoAbstractMethods subclass: #ASubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

Object subclass: #AnotherClassWithAnAbstractMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

AnotherClassWithAnAbstractMethod subclass: #ASubclassThatDoesntImplementTheMethodAndHasASubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

ASubclassThatDoesntImplementTheMethodAndHasASubclass subclass: #ALeafSubclassThatStillDoesntImplementTheMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

AnotherClassWithAnAbstractMethod subclass: #ASubclassThatImplementsTheMethodAndHasASubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

ASubclassThatImplementsTheMethodAndHasASubclass subclass: #ALeafSubclassThatDoesntImplementTheMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!ASubclassThatImplementsTheMethodAndHasASubclass methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 6/22/2013 18:44'!
m

	^1! !

!AnotherClassWithAnAbstractMethod methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/21/2013 21:59'!
m

	self subclassResponsibility! !

Object subclass: #XXX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Metaprogramacion1'!

!XXX methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 6/22/2013 23:10'!
lookForMissingImplementorsOf: aSelector ofClass: aClass

	| missingImplementors |
	
	(aClass canPerform: aSelector) ifTrue: [ ^Set new ] ifFalse: [
		(aClass subclasses isEmpty) ifTrue: [ ^Set with: aClass ] ifFalse: [
			missingImplementors := Set new.
			aClass subclassesDo: [ :aSubclass | missingImplementors := missingImplementors union: (self lookForMissingImplementorsOf: aSelector ofClass: aSubclass) ].
			^missingImplementors
		]
	]! !
